-- Use the `ref` function to select from other models
{{
    config(
        schema='DW_SALES',
        materialized='incremental',
        unique_key='ORDER_SK'
    )
}}

WITH QRY_LKP AS
 (SELECT 
    NVL(C.CUSTOMER_SK,-1) AS CUSTOMER_SK,
    NVL(N.NATION_SK,-1) AS NATION_SK,
	NVL(R.REGION_SK,-1) AS REGION_SK,
    O.ORDER_ID,
    O.ORDER_DATE,
    O.ORDER_STATUS,
	NVL(D.DATE_SK,-1) AS ORDER_DATE_SK,
    O.TOTAL_PRICE,
    ORDER_ID as AUDIT_ROW_NATURAL_KEY,
    MD5(CUSTOMER_SK || NATION_SK || REGION_SK || ORDER_DATE || TOTAL_PRICE) as AUDIT_UPDATE_CHECKSUM
 FROM {{ ref('STG_ORDERS') }} O
    LEFT JOIN {{ ref('DIM_CUSTOMER') }} C ON (O.CUSTOMER_ID = C.CUSTOMER_ID)
    LEFT JOIN {{ ref('DIM_NATION') }} N ON (O.NATION_ID = N.NATION_ID)
	LEFT JOIN {{ ref('DIM_REGION') }} R ON (O.REGION_ID = R.REGION_ID)
    LEFT JOIN {{ source('DW_SALES', 'DIM_DATE') }} D ON (O.ORDER_DATE = D.DATETIME))
	
 SELECT NVL(F.ORDER_SK,DW_SALES.FCT_ORDER_SEQ.nextval) ORDER_SK, 
    LKP.CUSTOMER_SK,
    LKP.NATION_SK,
    LKP.REGION_SK,
	LKP.ORDER_DATE_SK,
    LKP.ORDER_ID,
    LKP.ORDER_DATE,
    LKP.ORDER_STATUS,
    LKP.TOTAL_PRICE,
    LKP.AUDIT_ROW_NATURAL_KEY,
    LKP.AUDIT_UPDATE_CHECKSUM,
    NVL(F.AUDIT_CREATION_DATE_TIME,SYSDATE()) as AUDIT_CREATION_DATE_TIME,
    SYSDATE() as AUDIT_UPDATE_DATE_TIME,
    '{{ invocation_id }}' AS AUDIT_GUID   
 FROM QRY_LKP LKP
  LEFT JOIN DW_SALES.FCT_ORDERS F ON (LKP.AUDIT_ROW_NATURAL_KEY = F.AUDIT_ROW_NATURAL_KEY)
 WHERE LKP.AUDIT_UPDATE_CHECKSUM <> F.AUDIT_UPDATE_CHECKSUM OR F.AUDIT_UPDATE_CHECKSUM IS NULL	